//----------------------------------------------------------------------------
//  Project address
//  Some Company
//  Copyright 2000. All Rights reserved.
//
//  SUBSYSTEM:    address Application
//  FILE:         addressapp.cpp
//  AUTHOR:       Author
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TaddressAppl (TApplication).
//  (Generated by OWL 6.x Wizard for MS VC++. Version 1.5)
//----------------------------------------------------------------------------
#include "owlpch.h"

#include <owl/buttonga.h>
#include <owl/statusba.h>
#include <owl/cmdline.h>
#include <owl/registry.h>
#include <stdio.h>

#include "addressapp.h"
#include "addresscl.h" // Definition of client class.
#include "addressab.h"  // Definition of about dialog.


class MStatusBar: public TStatusBar{
	public:
		MStatusBar(TWindow* parent = 0,
               TGadget::TBorderStyle borderStyle = TGadget::Recessed,
               uint modeIndicators = 0,TFont* font = 0, TModule* module = 0)
			         :TStatusBar(parent,borderStyle,modeIndicators,font,module){}
		virtual void  SetHintText(LPCTSTR text){ SetText(text);}
};

//{{TAddressAppl Implementation}}

//
// Build a response table for all messages/commands handled
// by the application.
//
DEFINE_RESPONSE_TABLE1(TAddressAppl, TApplication)
//{{TAddressApplRSP_TBL_BEGIN}}
  EV_COMMAND(CM_HELPABOUT, CmHelpAbout),
//{{TAddressApplRSP_TBL_END}}
END_RESPONSE_TABLE;


//--------------------------------------------------------
// TAddressAppl
//

TAddressAppl::TAddressAppl() : TApplication(_T("Address List Manager"))
{
  // INSERT>> Your constructor code here.
}


TAddressAppl::~TAddressAppl()
{
  // INSERT>> Your destructor code here.
}

//--------------------------------------------------------
// TAddressAppl
// ~~~~~
// Application intialization.
//
void TAddressAppl::InitMainWindow()
{
  if (nCmdShow != SW_HIDE)
    nCmdShow = (nCmdShow != SW_SHOWMINNOACTIVE) ? SW_SHOWNORMAL : nCmdShow;

  TSDIDecFrame* frame = new TSDIDecFrame(0, GetName(), 0, true);
  
  // Disable sizeing of dialog frame
//  frame->ModifyStyle(WS_THICKFRAME|WS_MAXIMIZEBOX|WS_MINIMIZEBOX,0);
//  frame->ModifyStyle(WS_MAXIMIZEBOX|WS_MINIMIZEBOX,0);

  // Set frame size the same as dialog
  //
  frame->SetFlag(wfShrinkToClient);

  // Assign icons for this application.
  //
  frame->SetIcon(this, IDI_SDIAPPLICATION);
  frame->SetIconSm(this, IDI_SDIAPPLICATION);

  // Associate with the accelerator table.
  //
  frame->Attr.AccelTable = IDM_SDI; 
 
  TStatusBar* sb = new MStatusBar(frame, TGadget::Recessed);
  frame->Insert(*sb, TDecoratedFrame::Bottom);
  frame->SetBarDescr(new TBarDescr(IDM_SDI));
	TGadgetWindow::EnableFlatStyle();

  SetMainWindow(frame);

  // Menu associated with window.
  //
  frame->SetMenuDescr(TMenuDescr(IDM_SDI));
}

//--------------------------------------------------------
// TAddressAppl
// ~~~~~
// Application instance initialization.
//
void TAddressAppl::InitInstance()
{
  TApplication::InitInstance();

  ProcessCmdLine(GetCmdLine().c_str());

	GetMainWindow()->GetClientWindow()->PostMessage(WM_OPENDEFAULT);
}

//--------------------------------------------------------
// TAddressAppl
// ~~~~~
// Process command line parameters.
//
void TAddressAppl::ProcessCmdLine(LPCTSTR cmdLine)
{
  TCmdLine cmd(cmdLine);

  while (cmd.Kind != TCmdLine::Done) {
    if (cmd.Kind == TCmdLine::Option) {
      if (strnicmp(cmd.Token, "unregister", cmd.TokenLen) == 0) {
        UnRegisterInfo();
        return;
      }
    }
    cmd.NextToken();
  }

  RegisterInfo();
}


//--------------------------------------------------------
// TAddressAppl
// ~~~~~
// Register application info.
//
void TAddressAppl::RegisterInfo()
{
  TAPointer<_TCHAR> buffer = new _TCHAR[_MAX_PATH];

  GetModuleFileName(buffer, _MAX_PATH);

  TRegKey(TRegKey::GetClassesRoot(), _T("Address.Application\\DefaultIcon")).SetDefValue(0, REG_SZ, buffer, _tcslen(buffer));
  _tcscat(buffer, _T(",1"));

}


//--------------------------------------------------------
// TAddressAppl
// ~~~~~
// Unregister application info.
//
void TAddressAppl::UnRegisterInfo()
{
  TAPointer<_TCHAR> buffer = new _TCHAR[_MAX_PATH];

  GetModuleFileName(buffer, _MAX_PATH);

  TRegKey(TRegKey::GetClassesRoot(), _T("Address.Application")).DeleteKey(_T("DefaultIcon"));
  TRegKey(TRegKey::GetClassesRoot(), _T("Address.Document.1")).DeleteKey(_T("DefaultIcon"));
  TRegKey::ClassesRoot.DeleteKey(_T("Address.Application"));
}


//{{TSDIDecFrame Implementation}}


TSDIDecFrame::TSDIDecFrame(TWindow* parent, LPCTSTR title, TWindow* clientWnd, bool trackMenuSelection, TModule* module)
:
  TDecoratedFrame(parent, title, !clientWnd ? new TAddressWindow(0) : clientWnd, trackMenuSelection, module)
{
  // INSERT>> Your constructor code here.

}


TSDIDecFrame::~TSDIDecFrame()
{
  // INSERT>> Your destructor code here.

}

void TSDIDecFrame::SetupWindow()
{
  TDecoratedFrame::SetupWindow();
}


//--------------------------------------------------------
// TAddressAppl
// ~~~~~~~~~~~
// Menu Help About address command
//
void TAddressAppl::CmHelpAbout()
{
  // Show the modal dialog.
  //
  TAddressAboutDlg(GetMainWindow()).Execute();
}


//-------------------------------------------------------------------
// OwlMain
// ~~~~~~~
// Application Start here.
//
int OwlMain(int , LPTSTR [])
{
  return TAddressAppl().Run();
}
//
