//----------------------------------------------------------------------------
//  Project address
//  Some Company
//  Copyright 2000. All Rights reserved.
//
//  SUBSYSTEM:    address Application
//  FILE:         addresscl.cpp
//  AUTHOR:       Author
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TAddressWindow (TDialog).
//  (Generated by OWL 6.x Wizard for MS VC++. Version 1.5)
//----------------------------------------------------------------------------
#include "owlpch.h"

#include <owl/static.h>
#include <owl/edit.h>
#include <owl/opensave.h>
#if !defined(OWL_VALIDATE_H)
# include <owl/validate.h>
#endif
#include <owlfx/dbctrls.h>
#include "addressapp.h"
#include "addresscl.h" // Definition of client class.
#include "orderdlg.h"
#include "searchdlg.h"


//
static void 
FillCBox(TComboBoxData& cBox, TStringArray& array,TDewTable* table)
{
  const CURProps& props = table->GetTableProps();
	IDXDesc desc;
	for(int i = 0; i < props.iIndexes; i++){
    table->GetIndexDesc(i, desc);
		int index = array.Add(desc.szKeyExp);
		cBox.AddStringItem(desc.szTagName, (uint32)array[index].c_str());
	}
}

//{{TAddressWindow Implementation}}

//
// Build a response table for all messages/commands handled
// by the application.
//
DEFINE_RESPONSE_TABLE1(TAddressWindow, TDialog)
//{{TAddressWindowRSP_TBL_BEGIN}}
	EV_COMMAND(CM_FILENEW, CmFileNew),
	EV_COMMAND(CM_FILEOPEN, CmFileOpen),
	EV_COMMAND(CM_EDITFIND, CmEditFind),
	EV_COMMAND(CM_DBFIRST, CmDbfirst),
	EV_COMMAND(CM_DBPREV, CmDbprev),
	EV_COMMAND_ENABLE(CM_DBFIRST, CeDbfirst),
	EV_COMMAND_ENABLE(CM_DBPREV, CeDbprev),
	EV_COMMAND(CM_DBNEXT, CmDbnext),
	EV_COMMAND_ENABLE(CM_DBNEXT, CeDbnext),
	EV_COMMAND(CM_DBLAST, CmDblast),
	EV_COMMAND_ENABLE(CM_DBLAST, CeDblast),
	EV_COMMAND(CM_DELETETABLE, CmDeletetable),
	EV_COMMAND_ENABLE(CM_DELETETABLE, CeDeletetable),
	EV_COMMAND(CM_COMMIT, CmCommit),
	EV_COMMAND_ENABLE(CM_COMMIT, CeCommit),
	EV_COMMAND(CM_EDITADD, CmEditAdd),
	EV_COMMAND_ENABLE(CM_EDITADD, CeEditAdd),
	EV_COMMAND(CM_DELETERECORD, CmEditDelete),
	EV_COMMAND_ENABLE(CM_DELETERECORD, CeEditDelete),
	EV_COMMAND(CM_SETRANGE, CmSetrange),
	EV_COMMAND_ENABLE(CM_SETRANGE, CeSetrange),
	EV_COMMAND(CM_CLEARRANGE, CmClearrange),
	EV_COMMAND_ENABLE(CM_CLEARRANGE, CeClearrange),
	EV_COMMAND(CM_UNDORECORD, CmEditUndo),
	EV_COMMAND_ENABLE(CM_UNDORECORD, CeEditUndo),
	EV_COMMAND(CM_ORDER, CmOrder),
	EV_COMMAND_ENABLE(CM_ORDER, CeOrder),
	EV_MESSAGE(WM_OPENDEFAULT, EvOpenDefault),
	EV_EN_CHANGE(IDC_FNAME,		EvChange),
	EV_EN_CHANGE(IDC_LNAME,		EvChange),
	EV_EN_CHANGE(IDC_SPOUSE,	EvChange),
	EV_EN_CHANGE(IDC_FNAME,		EvChange),
	EV_EN_CHANGE(IDC_ADDR1,		EvChange),
	EV_EN_CHANGE(IDC_ADDR2,		EvChange),
	EV_EN_CHANGE(IDC_CITY,		EvChange),
	EV_EN_CHANGE(IDC_STATE,		EvChange),
	EV_EN_CHANGE(IDC_ZIP,			EvChange),
	EV_EN_CHANGE(IDC_WORKNO,	EvChange),
	EV_EN_CHANGE(IDC_HOMENO,	EvChange),
	EV_EN_CHANGE(IDC_COMMENTS,EvChange),
	EV_DTN_DATETIMECHANGE(IDC_LASTCNT, EvDTChanged),
//{{TAddressWindowRSP_TBL_END}}
END_RESPONSE_TABLE;


//--------------------------------------------------------
// TAddressWindow
// ~~~~~~~~~~
// Construction/Destruction handling.
//
TAddressWindow::TAddressWindow(TWindow* parent, TResId resId, TModule* module)
:
  TDialog(parent, resId, module),	
	Table(0),	
	CurIndex(_T("FULLNAME")),
	Dirty(false),
	Locked(false),
	EditNew(false)
{
//{{TAddressWindowXFER_USE}}
	StaticField1	= new TDBFiledName(this, IDC_FIELD1, 1, 0, 255);
	StaticField2	= new TDBFiledName(this, IDC_FIELD2, 2, 0, 255);
	StaticField3	= new TDBFiledName(this, IDC_FIELD3, 3, 0, 255);
	StaticFileD4	= new TDBFiledName(this, IDC_FILED4, 4, 0, 255);
	StaticField5	= new TDBFiledName(this, IDC_FIELD5, 5, 0, 255);
	StaticField6	= new TDBFiledName(this, IDC_FIELD6, 6, 0, 255);
	StaticFileD7	= new TDBFiledName(this, IDC_FILED7, 7, 0, 255);
	StaticFileD8	= new TDBFiledName(this, IDC_FILED8, 8, 0, 255);
	StaticFileD9	= new TDBFiledName(this, IDC_FILED9, 9, 0, 255);
	StaticFileD10 = new TDBFiledName(this, IDC_FILED10, 10, 0, 255);
	StaticFileD11 = new TDBFiledName(this, IDC_FILED11, 11, 0, 255);
	StaticFileD12 = new TDBFiledName(this, IDC_FILED12, 12, 0, 255);
	EditFname			= new TDBEdit(this, IDC_FNAME, 1, 0, NAMELEN-1);
	EditLname			= new TDBEdit(this, IDC_LNAME, 2, 0, NAMELEN-1);
	EditSpouse		= new TDBEdit(this, IDC_SPOUSE, 3, 0, ADDRESSLEN-1);
	EditAddr1			= new TDBEdit(this, IDC_ADDR1, 4, 0, ADDRESSLEN-1);
	EditAddr2			= new TDBEdit(this, IDC_ADDR2, 5, 0, ADDRESSLEN-1);
	EditCity			= new TDBEdit(this, IDC_CITY, 6, 0, CITYLEN-1);
	EditState			= new TDBEdit(this, IDC_STATE, 7, 0, STATELEN-1);
	EditZip				= new TDBEdit(this, IDC_ZIP, 8, 0, ZIPLEN-1);
	EditWorkno		= new TDBEdit(this, IDC_WORKNO, 9, 0, PHONELEN-1);
	EditHomeno		= new TDBEdit(this, IDC_HOMENO, 10, 0, PHONELEN-1);
	Lastcnt				= new TDBDate(this, IDC_LASTCNT,11);
	EditComments	= new TDBBlobEdit(this, IDC_COMMENTS, 12, 0, COMMENTLEN-1);
//{{TAddressWindowXFER_USE_END}}

}
//
TAddressWindow::~TAddressWindow()
{
	delete Table;
  Destroy();
}
//
void TAddressWindow::CmFileNew ()
{	
	// INSERT>> Your code here.
}
//
void TAddressWindow::CmFileOpen ()
{	
	TFileOpenDialog::TData data;
	TFileOpenDialog dlg(this, data);
	if(dlg.Execute() != IDOK) {
    if (data.Error != 0) {   // 0 value means user selected Cancel
      char  msg[50];
      wsprintf(msg, "GetOpenFileName returned Error #%ld", data.Error);
      MessageBox(msg, "WARNING", MB_OK|MB_ICONSTOP);
    }
  }
	else
		OpenDBase(data.FileName);
}
//
void TAddressWindow::CmEditFind ()
{	
	TSearchDlgXfer XFer;
	TStringArray array;
	FillCBox(XFer.SearchBox, array, Table);
	XFer.SearchBox.SelectString(CurIndex.c_str());
	*XFer.EditSearch = 0;
	XFer.Equal			 = 0;
	XFer.Greatereq	 = 1;
	XFer.Greater		 = 0;

	TSearchDlg dlg(this);
	dlg.SetTransferBuffer(&XFer);
	if(dlg.Execute()==IDOK){
		Locked = true;
    // Get the Production index's name, since it is a dBASE index.
		int curSel = XFer.SearchBox.GetSelIndex();
		owl_string index = XFer.SearchBox.GetStrings()[curSel];
    if(index!=CurIndex){
			CurIndex = index;
			IDXDesc desc;
			Table->GetIndexDesc(1, desc);
			Table->SwitchToIndex(desc.szName, true, 0, CurIndex.c_str());
		}
    // Get the Condition checkbox.
		DBISearchCond eSearch = keySEARCHEQ;
		if(XFer.Greatereq)
			eSearch = keySEARCHGEQ;
		else if(XFer.Greater)
			eSearch = keySEARCHGT;
		
    // Search based upon the condition and the search string.
		Table->InitRecord();
    TDewRecord& record = Table->GetCurRecord();
		try{
			record.SetField(curSel+1, owl_string(XFer.EditSearch));
			Table->SetToKey(eSearch);
		}
		catch(TDewNotFoundException&){
			MessageBox("Record not found");
			Table->SetToBegin();
		}
		catch(...){
			MessageBox("Record not found");
			Table->SetToBegin();
		}

		// Move one record past the crack that the Search
    // function leaves you at.
		//Table->GetNextRecord();
		Locked = false;
	}
}
//
void TAddressWindow::CmDbfirst ()
{	
	if(!CheckDirty())
		return;
	TWaitCursor w;
	Locked = true;
  Table->SetToBegin();
  Table->GetNextRecord();
	Locked = false;
}
//
void TAddressWindow::CeDbfirst (TCommandEnabler& tce)
{	
	tce.Enable(Table && !Table->IsFirst());
}
//
void TAddressWindow::CmDbprev ()
{	
	if(!CheckDirty())
		return;

	TWaitCursor w;
	Locked = true;
  Table->GetPriorRecord();
	Locked = false;
}
//
void TAddressWindow::CeDbprev (TCommandEnabler& tce)
{	
	tce.Enable(Table && !Table->IsFirst());
}
//
void TAddressWindow::CmDbnext ()
{	
	if(!CheckDirty())
		return;

	TWaitCursor w;
	Locked = true;
  Table->GetNextRecord();
	Locked = false;
}
//
void TAddressWindow::CeDbnext (TCommandEnabler& tce)
{	
	tce.Enable(Table && !Table->IsLast());
}
//
void TAddressWindow::CmDblast ()
{	
	if(!CheckDirty())
		return;

	TWaitCursor w;
	Locked = true;
  Table->SetToEnd();
  Table->GetPriorRecord();
	Locked = false;
}
//
void TAddressWindow::CeDblast (TCommandEnabler& tce)
{	
	tce.Enable(Table && !Table->IsLast());
}
//
void TAddressWindow::CmDeletetable ()
{	
  if(MessageBox("Delete This table?", 0, MB_ICONHAND|MB_YESNO)==IDYES){
		TAddressAppl* appl = TYPESAFE_DOWNCAST(GetApplication(),TAddressAppl);
		CHECK(appl);
		TWaitCursor w;
		Locked = true;
		
		// Add new record just to clear 
		// all dialog controls.
		Table->InitRecord();
		Table->AppendRecord();

		SetDBLink(0);
		delete Table;
		Table = 0;
		appl->Database.DeleteTable(TabeName.c_str());
		
		Locked = false;
  }
}
//
void TAddressWindow::CeDeletetable (TCommandEnabler& tce)
{	
	tce.Enable();
}
//
void TAddressWindow::CmCommit ()
{	
	if(Dirty && Table){
		Table->GetDataLink().CommitControls();
		Table->ModifyRecord();
	}
	Dirty = false; 
}
//
void TAddressWindow::CeCommit (TCommandEnabler& tce)
{	
	tce.Enable(Table && Dirty);
}
//
void TAddressWindow::CmEditAdd ()
{	
	Table->InitRecord();
  Table->AppendRecord();
	Dirty = true;
	EditNew	= true;
}
//
void TAddressWindow::CeEditAdd (TCommandEnabler& tce)
{	
	tce.Enable(Table);
}
//
void TAddressWindow::CmEditDelete ()
{	
	if(MessageBox("Delete current record?",0, MB_ICONHAND|MB_YESNO)==IDYES){
		TWaitCursor w;
		Locked = true;
    Table->DeleteRecord();
		if(!Table->IsLast())
			Table->GetNextRecord();
    else if(!Table->IsFirst())
		  Table->GetPriorRecord();
		Locked = false;
  }
}
//
void TAddressWindow::CeEditDelete (TCommandEnabler& tce)
{	
	tce.Enable(Table);
}
//
void TAddressWindow::CmSetrange ()
{	
	// INSERT>> Your code here.
}
//
void TAddressWindow::CeSetrange (TCommandEnabler& tce)
{	
	tce.Enable(Table);
}
//
void TAddressWindow::CmClearrange ()
{	
	// INSERT>> Your code here.
}
//
void TAddressWindow::CeClearrange (TCommandEnabler& tce)
{	
	tce.Enable(Table);
}
//
void TAddressWindow::UndoNewRecord()
{
	if(EditNew){
		Locked = true;
		Table->DeleteRecord();
		if(!Table->IsLast())
			Table->GetNextRecord();
    else if(!Table->IsFirst())
		  Table->GetPriorRecord();
		EditNew = false;
		Locked = false;
		Dirty		= false;
	}
}
//
void TAddressWindow::CmEditUndo ()
{	
	if(MessageBox("All changes will be lost - Undo anyway?", 0, MB_OKCANCEL) == IDOK){
		if(EditNew)
			UndoNewRecord();
		else
			RefreshDisplay();
	}
}
//
void TAddressWindow::CeEditUndo (TCommandEnabler& tce)
{	
	tce.Enable(Table && Dirty);
}
//
void TAddressWindow::CmOrder ()
{	
	TOrderDlgXfer XFer;
	TStringArray array;
	FillCBox(XFer.Order, array, Table);
	XFer.Order.SelectString(CurIndex.c_str());

	TOrderDlg dlg(this);
	dlg.SetTransferBuffer(&XFer);
	if(dlg.Execute()==IDOK && 
		 CurIndex != XFer.Order.GetStrings()[XFer.Order.GetSelIndex()]){
    // Get the Production index's name, since it is a dBASE index.
		CurIndex = XFer.Order.GetStrings()[XFer.Order.GetSelIndex()];
		IDXDesc desc;
    Table->GetIndexDesc(1, desc);
	  Table->SwitchToIndex(desc.szName, true, 0, CurIndex.c_str());
	}
}
//
void TAddressWindow::CeOrder (TCommandEnabler& tce)
{	
	tce.Enable(Table);
}
//
TResult TAddressWindow::EvOpenDefault(TParam1, TParam2)
{
	OpenDBase(_T("..\\tables\\personal.dbf"));
//	OpenDBase(_T("personal.dbf"));
	return 0;		
}
//
void TAddressWindow::OpenDBase(LPCTSTR dBaseName)
{
	TAddressAppl* appl = TYPESAFE_DOWNCAST(GetApplication(),TAddressAppl);
	CHECK(appl);

	TDewTable* table;
	try{
		table = new TDewTable(appl->Database, dBaseName);
	}
	catch(TDewException&){ 
		owl_string message = _T("Fail to Open DBase: ");
		message += dBaseName;
		MessageBox(message.c_str());
		return;
	}
	delete Table;
	Table	= table;
	Dirty		= false;
	TabeName = dBaseName;
	
  // Switch to the an index.  This is done because we are
  // using a dBASE table which defaults to no index upon being
  // opened.  You can choose any index by changing the
  // szInitIndex variable.
 
	try{
		Table->SetToBegin();
	  Table->Advance();
    // Get the Production index's name, since it is a dBASE index.
		IDXDesc desc;
    Table->GetIndexDesc(1, desc);
	  Table->SwitchToIndex(desc.szName, true, 0, CurIndex.c_str());
	}
	catch(TDewException&){ 
		MessageBox("Fail to Open Index");
	}

	// Goto the top of the table and move forward one record.
	Locked = true;
  Table->SetToBegin();
  Table->Advance();
	SetDBLink(&Table->GetDataLink());
	SetValidators();
	Locked = false;
  RefreshDisplay();
}
//  
void TAddressWindow::SetDBLink(TDBDataLink* link)
{
	StaticField1->SetDBLink(link);
	StaticField2->SetDBLink(link);
	StaticField3->SetDBLink(link);
	StaticFileD4->SetDBLink(link);
	StaticField5->SetDBLink(link);
	StaticField6->SetDBLink(link);
	StaticFileD7->SetDBLink(link);
	StaticFileD8->SetDBLink(link);
	StaticFileD9->SetDBLink(link);
	StaticFileD10->SetDBLink(link);
	StaticFileD11->SetDBLink(link);
	StaticFileD12->SetDBLink(link);
	
	EditFname->SetDBLink(link);
	EditLname->SetDBLink(link);
	EditSpouse->SetDBLink(link);
	EditAddr1->SetDBLink(link);
	EditAddr2->SetDBLink(link);
	EditCity->SetDBLink(link);
	EditState->SetDBLink(link);
	EditZip->SetDBLink(link);
	EditWorkno->SetDBLink(link);
	EditHomeno->SetDBLink(link);
	Lastcnt->SetDBLink(link);
	EditComments->SetDBLink(link);
}
//  
void TAddressWindow::SetValidators()
{
  //pcFLDDesc fields = Table->FieldDescs();
  //EditFname->SetValidator(new TFilterValidator("A-Za-z. "));
	EditWorkno->SetValidator(new TPXPictureValidator("{[(###)] ###-####},<blank>"));
	EditHomeno->SetValidator(new TPXPictureValidator("{[(###)] ###-####},<blank>"));
}
//  
void TAddressWindow::RefreshDisplay()
{
	Locked = true;
	Table->GetDataLink().RefreshControls();
	Dirty = false;
	Locked = false;
}
//
int TAddressWindow::EvDTChanged(TDateTimeChange far& not)
{	
	EvChange();	
	return 0;
}
//
void TAddressWindow::EvChange()
{	
	if(!Locked)
		Dirty = true;
}
//
bool TAddressWindow::CheckDirty()
{
	if(!Dirty)
		return true;
	if(MessageBox("Data not saved move to next record anyway?",0, MB_OKCANCEL)==IDCANCEL)
		return false;
	if(EditNew)
		UndoNewRecord();
	Dirty = false;
	return true;
}
//
//
// Utilities
//
