//----------------------------------------------------------------------------
//  Project address
//  Some Company
//  Copyright 2000. All Rights reserved.
//
//  SUBSYSTEM:    address Application
//  FILE:         addresscl.h
//  AUTHOR:       Author
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TAddressWindow (TDialog).
//  (Generated by OWL 6.0 Wizard for MS VC++. Version 1.5)
//----------------------------------------------------------------------------
#if !defined(addresscl_h) // Sentry, use file only if it's not already included.
#define addresscl_h

#include "resource.h"                  // Definition of all resources.

__OWLFX_DECLCLASS(TDBFiledName);
__OWLFX_DECLCLASS(TDBEdit);
__OWLFX_DECLCLASS(TDBDate);
__OWLFX_DECLCLASS(TDBBlobEdit);

#define NAMELEN     20
#define ADDRESSLEN  40
#define CITYLEN     20
#define STATELEN     3
#define ZIPLEN      13
#define PHONELEN    21
#define DATELEN     12
#define COMMENTLEN  300

//{{TDialog = TAddressWindow}}

class TAddressWindow : public TDialog {
  public:
    TAddressWindow(TWindow* parent, TResId resId = IDD_CLIENT, TModule* module = 0);
    virtual ~TAddressWindow();
		
		void OpenDBase(LPCTSTR dBaseName);
		void RefreshDisplay();
		void SetDBLink(TDBDataLink* link);
		bool CheckDirty();
		void SetValidators();
		void UndoNewRecord();

	protected: // data
		TDewTable*	Table;
		owl_string  CurIndex;
		owl_string  TabeName;
		bool				Dirty;
		bool				Locked;
		bool				EditNew;

//{{TAddressWindowXFER_DEF}}
		protected:
			TDBFiledName*	StaticField1;
			TDBFiledName*	StaticField2;
			TDBFiledName*	StaticField3;
			TDBFiledName*	StaticFileD4;
			TDBFiledName*	StaticField5;
			TDBFiledName*	StaticField6;
			TDBFiledName*	StaticFileD7;
			TDBFiledName*	StaticFileD8;
			TDBFiledName*	StaticFileD9;
			TDBFiledName*	StaticFileD10;
			TDBFiledName*	StaticFileD11;
			TDBFiledName*	StaticFileD12;
			TDBEdit*			EditFname;
			TDBEdit*			EditLname;
			TDBEdit*			EditSpouse;
			TDBEdit*			EditAddr1;
			TDBEdit*			EditAddr2;
			TDBEdit*			EditCity;
			TDBEdit*			EditState;
			TDBEdit*			EditZip;
			TDBEdit*			EditWorkno;
			TDBEdit*			EditHomeno;
			TDBDate*			Lastcnt;
			TDBBlobEdit*	EditComments;
//{{TAddressWindowXFER_DEF_END}}

//{{TAddressWindowRSP_TBL_BEGIN}}
	protected:
		void CmFileNew ();
		void CmFileOpen ();
		void CmEditFind ();
		void CmDbfirst ();
		void CmDbprev ();
		void CeDbfirst (TCommandEnabler& tce);
		void CeDbprev (TCommandEnabler& tce);
		void CmDbnext ();
		void CeDbnext (TCommandEnabler& tce);
		void CmDblast ();
		void CeDblast (TCommandEnabler& tce);
		void CmDeletetable ();
		void CeDeletetable (TCommandEnabler& tce);
		void CmCommit ();
		void CeCommit (TCommandEnabler& tce);
		void CmEditAdd ();
		void CeEditAdd (TCommandEnabler& tce);
		void CmEditDelete ();
		void CeEditDelete (TCommandEnabler& tce);
		void CmSetrange ();
		void CeSetrange (TCommandEnabler& tce);
		void CmClearrange ();
		void CeClearrange (TCommandEnabler& tce);
		void CmEditUndo ();
		void CeEditUndo (TCommandEnabler& tce);
		void CmOrder ();
		void CeOrder (TCommandEnabler& tce);
		TResult EvOpenDefault(TParam1 p1, TParam2 p2);
		void EvChange();
		int  EvDTChanged(__OWL TDateTimeChange& not);
//{{TAddressWindowRSP_TBL_END}}

		DECLARE_RESPONSE_TABLE(TAddressWindow);
};    //{{TAddressWindow}}

#endif  // addresscl_h sentry.
